let lastTapTime = 0;
Page({
  data: {
    latitude: 25.470415, // 默认中心纬度
    longitude: 110.273511, // 默认中心经度
    scale: 5,
    markers: [], // 初始化为空数组，后续动态填充
    showOverlay: false, // 是否显示图层
    mapContext: null, // 地图上下文对象
    excelData: []
  },

  onLoad() {
    // 假设已将 Excel 数据解析为以下数组
    const excelData = [
      { 土壤编号: "土1", 地点: "广西武鸣", dust_emissions: 5.34, longitude: 106.476143, latitude: 23.891756 },
      { 土壤编号: "土2", 地点: "广西河池", dust_emissions: 3.96, longitude: 107.476143, latitude: 24.891756 },
      { 土壤编号: "土3", 地点: "海南澄迈老城镇罗驿村委会罗驿洋", dust_emissions: 4.56, longitude: 110.125, latitude: 19.901756 },
      { 土壤编号: "土4", 地点: "广东江门新会", dust_emissions: 4.0, longitude: 109.476143, latitude: 22.461756 },
      { 土壤编号: "土5", 地点: "广州增城Z6", dust_emissions: 4.77, longitude: 110.476143, latitude: 21.891756 },
      { 土壤编号: "土6", 地点: "广州增城Z8", dust_emissions: 4.59, longitude: 111.476143, latitude: 22.891756 },
      { 土壤编号: "土7", 地点: "湖南岳阳", dust_emissions: 5.14, longitude: 112.476143, latitude: 23.891756 },
      { 土壤编号: "土8", 地点: "广东韶关武江", dust_emissions: 5.07, longitude: 113.476143, latitude: 24.891756 },
      { 土壤编号: "土9", 地点: "海南临高头星村", dust_emissions: 4.12, longitude: 109.684993, latitude: 19.83774 },
      { 土壤编号: "土10", 地点: "海南临高周礼村", dust_emissions: 5.0, longitude: 109.710703, latitude: 19.89222 },
      { 土壤编号: "土11", 地点: "海南澄迈金江", dust_emissions: 4.6, longitude: 110.069537, latitude: 19.81189 },
      { 土壤编号: "土12", 地点: "海南临高南贤村", dust_emissions: 4.2, longitude: 109.768714, latitude: 19.874323 },
      { 土壤编号: "土13", 地点: "海南澄迈金江北让村", dust_emissions: 4.5, longitude: 110.096765, latitude: 19.814288 },
      { 土壤编号: "土14", 地点: "广西扶绥", dust_emissions: 4.71, longitude: 107.7717789, latitude: 22.5166902 },
      { 土壤编号: "土15", 地点: "广西江州", dust_emissions: 4.31, longitude: 107.56347787, latitude: 22.6022203 },
      { 土壤编号: "土16", 地点: "广西龙州", dust_emissions: 5.15, longitude: 106.7870847, latitude: 22.3496497 },
      { 土壤编号: "土17", 地点: "广西大新", dust_emissions: 4.71, longitude: 107.0230641, latitude: 22.5857946 },
      { 土壤编号: "土18", 地点: "湖南岳阳荣家湾", dust_emissions: 5.04, longitude: 113.059629, latitude: 29.267061 },
      { 土壤编号: "土19", 地点: "湖南长沙", dust_emissions: 5.08, longitude: 113.059629, latitude: 28.440613 },
      { 土壤编号: "土20", 地点: "浙江", dust_emissions: 4.8, longitude: 111.45527, latitude: 24.395235 },
      { 土壤编号: "土21", 地点: "云南陆良", dust_emissions: 4.67, longitude: 112.45527, latitude: 25.395235 },
      { 土壤编号: "土22", 地点: "南昌横龙镇南园组", dust_emissions: 4.8, longitude: 113.45527, latitude: 26.395235 },
      { 土壤编号: "土23", 地点: "南昌横龙枫塘南园", dust_emissions: 5.1, longitude: 114.45527, latitude: 27.395235 },
      { 土壤编号: "土24", 地点: "南昌横龙镇院塘村", dust_emissions: 4.27, longitude: 114.852, latitude: 27.3947 },
      { 土壤编号: "土25", 地点: "江西山庄乡秀水村黄田组", dust_emissions: 4.27, longitude: 114.852, latitude: 27.5247 },
      { 土壤编号: "土26", 地点: "贵州双星村", dust_emissions: 4.7, longitude: 106.852, latitude: 27.3147},
      { 土壤编号: "土27", 地点: "湖南永州八宝镇唐家州", dust_emissions: 4.57, longitude: 113.952, latitude: 26.08147 },
      { 土壤编号: "土28", 地点: "湖南永州金洞", dust_emissions: 5.3, longitude: 112.1564, latitude: 26.1685 },
      { 土壤编号: "土29", 地点: "祁阳县中国农业科学院红壤实验室", dust_emissions: 4.75, longitude: 111.4, latitude: 22.24 },
      { 土壤编号: "土30", 地点: "福建福州1", dust_emissions: 4.31, longitude: 112.4, latitude: 23.24 },
      { 土壤编号: "土31", 地点: "福建福州2", dust_emissions: 4.38, longitude: 113.4, latitude: 24.24 },
      { 土壤编号: "土32", 地点: "广东省韶关市南雄市下塅村", dust_emissions: 5.51, longitude: 114.4, latitude: 25.24 },
      { 土壤编号: "土33", 地点: "广东省韶关市南雄市河塘西216米", dust_emissions: 6.44, longitude: 114.28, latitude: 25.14 },
      { 土壤编号: "土34", 地点: "广东省韶关市南雄市上何屋西南500米", dust_emissions: 5.25, longitude: 114.15, latitude: 24.86 },
      { 土壤编号: "土35", 地点: "广东省南雄市雄州街道林屋", dust_emissions: 4.62333333333333, longitude: 114.23, latitude: 25.4 },
      { 土壤编号: "土36", 地点: "广东省台山都斛镇", dust_emissions: 3.0, longitude: 112.34, latitude: 27.31 },
      { 土壤编号: "土52", 地点: "湖南省长沙市浏阳市永安镇千鹭湖", dust_emissions: 4.72333333333333, longitude: 113.34, latitude: 28.31 },
      { 土壤编号: "土53", 地点: "湖南省长沙市浏阳市湖南农大实习基地", dust_emissions: 5.55333333333333, longitude: 113.83, latitude: 28.3 },
      { 土壤编号: "土54", 地点: "湖南省邵阳市罗市镇1", dust_emissions: 4.64, longitude: 110.35, latitude: 25.47 },
      { 土壤编号: "土55", 地点: "湖南省邵阳市罗市镇2", dust_emissions: 5.01333333333333, longitude: 111.35, latitude: 26.47 },
      { 土壤编号: "土56", 地点: "湖南省邵阳市罗市镇3", dust_emissions: 5.18, longitude: 112.35, latitude: 27.47 },
      { 土壤编号: "土57", 地点: "长沙县高桥镇的省农科院高桥科研基地1", dust_emissions: 5.1, longitude: 113.35, latitude: 28.47 },
      { 土壤编号: "土58", 地点: "长沙县高桥镇的省农科院高桥科研基地2", dust_emissions: 4.92, longitude: 113.35, latitude: 28.47 },
      { 土壤编号: "土59", 地点: "湖南省长沙市望城区桐林坳社区", dust_emissions: 3.0, longitude: 112.8, latitude: 28.37 },
      { 土壤编号: "土60", 地点: "湖南省益阳市赫山区泥江口镇", dust_emissions: 3.0, longitude: 107.37, latitude: 21.92 },
      { 土壤编号: "土70", 地点: "南宁市兴宁区柳杨路26号", dust_emissions: 3.0, longitude: 108.37, latitude: 22.92 },
      { 土壤编号: "土71", 地点: "南宁市兴宁区柳杨路广西私享家家具用品", dust_emissions: 3.0, longitude: 108.37, latitude: 23.94 },
      { 土壤编号: "土72", 地点: "南宁市兴宁区004乡道", dust_emissions: 6.24666666666667, longitude: 108.39, latitude: 24.92 },
      { 土壤编号: "土73", 地点: "南宁市兴宁区G7201南宁绕城高速", dust_emissions: 3.0, longitude: 108.4, latitude: 25.94 },
      { 土壤编号: "土74", 地点: "南宁市兴宁区012县道", dust_emissions: 3.0, longitude: 108.41, latitude: 26.92 },
      { 土壤编号: "土75", 地点: "南宁市兴宁区那况路168号", dust_emissions: 3.0, longitude: 108.4, latitude: 27.9 },
      { 土壤编号: "土76", 地点: "南宁市西乡塘区翊武路", dust_emissions: 5.37, longitude: 108.35, latitude: 28.96 },
      { 土壤编号: "土77", 地点: "南宁市西乡塘区坛洛镇", dust_emissions: 3.0, longitude: 107.85, latitude: 29.92 },
      { 土壤编号: "土81", 地点: "铜仁职业技术学院", dust_emissions: 4.0, longitude: 108.85, latitude: 27.34 },
      { 土壤编号: "土87", 地点: "江西省红壤及种质资源研究所(进贤基地)1", dust_emissions: 4.55, longitude: 116.17, latitude: 28.34 },
      { 土壤编号: "土88", 地点: "江西省红壤及种质资源研究所(进贤基地)2", dust_emissions: 4.99333333333333, longitude: 116.17, latitude: 28.34 }
    ];
    
    // 保存数据到data和实例变量
    this.setData({ excelData });
    this.excelData = excelData;

    // 动态生成 markers 数据
    const markers = excelData.map((item, index) => ({
      id: index + 1, // 标记点 ID
      latitude: item.latitude, // 纬度
      longitude: item.longitude, // 经度
      iconPath: "../../assets/taddar/marker.png", // 标记点图标路径
      width: 34,
      height: 34,
      callout: {
        content: `${item.地点} - pH值: ${parseFloat(item.dust_emissions).toFixed(2)}`, // 显示地名和污染物排放量
        display: "BYCLICK", // 点击时显示气泡
        fontSize: 14,
        color: "#333",
        bgColor: "#fff",
        borderColor: "#ccc",
        borderRadius: 5,
        borderWidth: 1,
        padding: 10,
        textAlign: "center",
        anchorX: 0.5,
        anchorY: -5
      }
    }));

    // 更新 markers 数据
    this.setData({ 
      markers,
      mapContext: wx.createMapContext("map", this) 
    });
  },

  // 切换图层显示
  toggleOverlay(e) {

    const showOverlay = e.detail.value;
    this.setData({ showOverlay });
    if (showOverlay) {
      console.log("准备添加地面覆盖物");
      // 添加地面覆盖物
      this.data.mapContext.addGroundOverlay({
        id: 1, // 覆盖物 ID
        src: 'https://soilgd.com/images/farmland_cut.png',// 图片路径
        bounds: {
          southwest: { latitude: 18.03, longitude: 104.25 }, // 图左下角坐标
          northeast: { latitude: 31.26, longitude: 119.86 }  // 图片右上角坐标
        },
        opacity: 0.7, // 图片透明度
        zIndex: 999, // 设置较高的 zIndex
        success: (res) => {
          console.log('添加地面覆盖物成功', res);
        },
        fail: (err) => {
          console.error('添加地面覆盖物失败', err);
        }
      });
    } else {
      console.log("准备移除地面覆盖物");
      // 移除地面覆盖物
      this.data.mapContext.removeGroundOverlay({
        id: 1, // 覆盖物 ID
        success: (res) => {
          console.log('移除地面覆盖物成功', res);
        },
        fail: (err) => {
          console.error('移除地面覆盖物失败', err);
        }
      });
    }
  },

   onMarkerTap(e) {
    const markerId = e.detail.markerId;
    
    // 不处理临时标记点击
    if (markerId === 0) return;

    const markers = this.data.markers.map(marker => {
      if (marker.id === markerId) {
        marker.callout.display = "ALWAYS";
      } else if (marker.id !== 0) { // 保持临时标记显示
        marker.callout.display = "NEVER";
      }
      return marker;
    });
    
    this.setData({ markers });
  },

  onCalloutTap(e) {
    console.log("Callout clicked:", e.detail.markerId);
  },

  handleMapTap(e) {
    const now = Date.now();
    if (now - lastTapTime < 1000) return;
    lastTapTime = now;
  
    const { latitude, longitude } = e.detail;
    
    wx.qqmapsdk.reverseGeocoder({
      location: { latitude, longitude },
      success: (res) => {
        const address = res.result.address_component;
        const locationDesc = res.result.location_description || '';
        const isValidLand = (
          address.nation === '中国' &&
          !['香港', '澳门', '台湾'].includes(address.province) &&
          address.city !== '三沙市' && // 排除南海海域行政中心
          !locationDesc.includes('海域') && // 排除描述含海域的关键词
          address.district !== '' // 排除无区县信息区域
        );

        if (isValidLand) {
          wx.showLoading({ title: '计算中...' });
          
          // 调用克里金插值接口
          wx.request({
            url: 'https://soilgd.com:5000/kriging_interpolation',
            method: 'POST',
            header: { 'Content-Type': 'application/json' },
            data: {
              file_name: 'emissions.xlsx',
              emission_column: 'dust_emissions',
              points: [[longitude, latitude]] // 注意顺序：经度在前
            },
            success: (res) => {
              wx.hideLoading();
              if (res.statusCode === 200 && res.data.interpolated_concentrations) {
                const value = res.data.interpolated_concentrations[0];
                
                // 创建临时标记
                const tempMarker = {
                  id: 0,
                  latitude,
                  longitude,
                  iconPath: "../../assets/taddar/marker.png",
                  width: 40,
                  height: 40,
                  callout: {
                    content: `经度: ${longitude.toFixed(4)}\n纬度: ${latitude.toFixed(4)}\npH值: ${value.toFixed(2)}`,
                    display: "ALWAYS",
                    fontSize: 14,
                    color: "#333",
                    bgColor: "#fff",
                    borderColor: "#07c160",
                    borderRadius: 8,
                    borderWidth: 2,
                    padding: 12,
                    anchorY: -10
                  }
                };
  
                // 更新标记数组
                const markers = this.data.markers
                  .filter(m => m.id !== 0)
                  .concat(tempMarker);
                this.setData({ markers });
              }
            },
            fail: (err) => {
              wx.hideLoading();
              wx.showToast({ title: '计算失败', icon: 'none' });
            }
          });
        } else {
          wx.showToast({ title: '非有效陆地区域', icon: 'none' });
        }
      },
      fail: (err) => console.error('接口错误:', err)
    });
  },

});